package code

const (
	OK uint32 = 0
)

// Scope
const (
	Unset uint32 = iota
	CloudEPPortalGW
	CloudEPMember
)

// Category for general operations: 100 - 4900
const (
	_               = iota
	CatInput uint32 = iota * 100
	CatDB
	CatResource
	CatGRPC
	CatAuth
	CatSystem
	CatPubSub
)

// CatArk Category for specific app/service: 5000 - 9900
const (
	CatArk uint32 = (iota + 50) * 100
)

// Detail - Input 1xx
const (
	_ = iota + CatInput
	InvalidFormat
	NotValidImplementation
	InvalidRange
)

// Detail - Database 2xx
const (
	_       = iota + CatDB
	DBError // general error
	DBDataConvert
	DBDuplicate
)

// Detail - Resource 3xx
const (
	_ = iota + CatResource
	ResourceNotFound
	InvalidResourceFormat
	ResourceAlreadyExist
	ResourceInsufficient
	InsufficientPermission
	InvalidMeasurementID
	ResourceExpired
	ResourceMigrated
	InvalidResourceState
	InsufficientQuota
	ResourceHasMultiOwner
)

/* Detail - GRPC */
// The GRPC detail code uses Go GRPC's built-in codes.
// Refer to "google.golang.org/grpc/codes" for more detail.

// Detail - Auth 5xx
const (
	_ = iota + CatAuth
	Unauthorized
	AuthExpired
	InvalidPosixTime
	SigAndPayloadNotMatched
	Forbidden
)

// Detail - System 6xx
const (
	_ = iota + CatSystem
	SystemInternalError
	SystemMaintainError
	SystemTimeoutError
)

// Detail - PubSub 7xx
const (
	_ = iota + CatPubSub
	Publish
	Consume
	MsgSizeTooLarge
)

// Detail - Ark 5xxx
const (
	_ = iota + CatArk
	ArkInternal
	ArkHttp400
)
